Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 100)
@@ -27,19 +27,21 @@
   typedef enum
     {
-      ROB_EMPTY                     , // 
-      ROB_BRANCH_WAIT_END           , // 
-      ROB_BRANCH_COMPLETE           , // 
-      ROB_STORE_WAIT_HEAD_OK        , // 
-//    ROB_STORE_WAIT_HEAD_KO        , // 
-      ROB_STORE_HEAD_OK             , // 
-      ROB_STORE_HEAD_KO             , // 
-      ROB_OTHER_WAIT_END            , // 
-      ROB_MISS_WAIT_END             , // 
-      ROB_END_OK_SPECULATIVE        , // 
-      ROB_END_OK                    , // 
-      ROB_END_KO_SPECULATIVE        , // 
-      ROB_END_KO                    , // 
-      ROB_END_MISS                  , // 
-      ROB_END_EXCEPTION_WAIT_HEAD   , // 
+      ROB_EMPTY                      , // 
+      ROB_BRANCH_WAIT_END            , // 
+      ROB_BRANCH_COMPLETE            , // 
+      ROB_STORE_WAIT_HEAD_OK         , // 
+//    ROB_STORE_WAIT_HEAD_KO         , // 
+      ROB_STORE_HEAD_OK              , // 
+      ROB_STORE_HEAD_KO              , // 
+      ROB_OTHER_WAIT_END             , // 
+      ROB_MISS_WAIT_END              , // 
+      ROB_END_OK_SPECULATIVE         , // 
+      ROB_END_OK                     , // 
+      ROB_END_KO_SPECULATIVE         , // 
+      ROB_END_KO                     , // 
+      ROB_END_BRANCH_MISS_SPECULATIVE, // 
+      ROB_END_BRANCH_MISS            , // 
+      ROB_END_MISS                   , // 
+      ROB_END_EXCEPTION_WAIT_HEAD    , // 
       ROB_END_EXCEPTION               // 
     } rob_state_t;
@@ -79,5 +81,4 @@
   public  : Tspecial_address_t num_reg_re_phy_new      ;
 
-  public  : Tevent_state_t     event_state             ;
   public  : Texception_t       exception               ;
   public  : Texception_t       exception_use           ;
@@ -161,19 +162,23 @@
     switch (x)
       {
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_EMPTY                     : return "empty"                     ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_WAIT_END           : return "branch_wait_end"           ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_COMPLETE           : return "branch_complete"           ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_OK        : return "store_wait_head_ok"        ; break;
-//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_KO        : return "store_wait_head_ko"        ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_OK             : return "store_head_ok"             ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_KO             : return "store_head_ko"             ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_OTHER_WAIT_END            : return "other_wait_end"            ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_MISS_WAIT_END             : return "miss_wait_end"             ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK_SPECULATIVE        : return "end_ok_speculative"        ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK                    : return "end_ok"                    ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO_SPECULATIVE        : return "end_ko_speculative"        ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO                    : return "end_ko"                    ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION_WAIT_HEAD   : return "end_exception_wait_head"   ; break;
-      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION             : return "end_exception"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_EMPTY                      : return "ROB_EMPTY"                       ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_WAIT_END            : return "ROB_BRANCH_WAIT_END"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_COMPLETE            : return "ROB_BRANCH_COMPLETE"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_OK         : return "ROB_STORE_WAIT_HEAD_OK"          ; break;
+//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_KO         : return "ROB_STORE_WAIT_HEAD_KO"          ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_OK              : return "ROB_STORE_HEAD_OK"               ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_KO              : return "ROB_STORE_HEAD_KO"               ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_OTHER_WAIT_END             : return "ROB_OTHER_WAIT_END"              ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_MISS_WAIT_END              : return "ROB_MISS_WAIT_END"               ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK_SPECULATIVE         : return "ROB_END_OK_SPECULATIVE"          ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK                     : return "ROB_END_OK"                      ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO_SPECULATIVE         : return "ROB_END_KO_SPECULATIVE"          ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO                     : return "ROB_END_KO"                      ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_BRANCH_MISS_SPECULATIVE: return "ROB_END_BRANCH_MISS_SPECULATIVE" ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_BRANCH_MISS            : return "ROB_END_BRANCH_MISS"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_MISS                   : return "ROB_END_MISS"                    ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION_WAIT_HEAD    : return "ROB_END_EXCEPTION_WAIT_HEAD"     ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION              : return "ROB_END_EXCEPTION"               ; break;
+
       default    : return ""      ; break;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 100)
@@ -272,16 +272,12 @@
 
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    _rob = new std::list<entry_t*> [_param->_nb_bank];
+    ALLOC1(_rob                   ,std::list<entry_t*>,_param->_nb_bank);
     
-    reg_BANK_PTR           = new uint32_t     [_param->_nb_bank];
-
-    reg_NB_INST_COMMIT_ALL = new Tcounter_t * [_param->_nb_front_end];
-    reg_NB_INST_COMMIT_MEM = new Tcounter_t * [_param->_nb_front_end];
+    ALLOC1(reg_BANK_PTR           ,uint32_t      ,_param->_nb_bank);
+
+    ALLOC2(reg_NB_INST_COMMIT_ALL ,Tcounter_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
+    ALLOC2(reg_NB_INST_COMMIT_MEM ,Tcounter_t    ,_param->_nb_front_end,_param->_nb_context [it1]);
     
-    for (uint32_t i=0; i<_param->_nb_front_end; i++)
-      {
-	reg_NB_INST_COMMIT_ALL [i] = new Tcounter_t [_param->_nb_context [i]];
-	reg_NB_INST_COMMIT_MEM [i] = new Tcounter_t [_param->_nb_context [i]];
-      }
+    ALLOC2(reg_EVENT_STATE        ,Tevent_state_t,_param->_nb_front_end,_param->_nb_context [it1]);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_deallocation.cpp	(revision 100)
@@ -178,15 +178,9 @@
         
         // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-        for (uint32_t i=0; i<_param->_nb_front_end; i++)
-          {
-            delete [] reg_NB_INST_COMMIT_ALL [i];
-            delete [] reg_NB_INST_COMMIT_MEM [i];
-          }
-        delete [] reg_NB_INST_COMMIT_ALL;
-        delete [] reg_NB_INST_COMMIT_MEM;
-        
-        delete [] reg_BANK_PTR;
-        
-        delete [] _rob;
+        DELETE1(_rob                   ,_param->_nb_bank);
+        DELETE1(reg_BANK_PTR           ,_param->_nb_bank);
+        DELETE2(reg_NB_INST_COMMIT_ALL ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_NB_INST_COMMIT_MEM ,_param->_nb_front_end,_param->_nb_context [it1]);
+        DELETE2(reg_EVENT_STATE        ,_param->_nb_front_end,_param->_nb_context [it1]);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_commit.cpp	(revision 100)
@@ -30,4 +30,5 @@
     uint32_t           bank_nb_access    [_param->_nb_bank];
     Tcontrol_t         commit_ack        [_param->_nb_inst_commit];
+
     // Initialisation
     for (uint32_t i=0; i<_param->_nb_bank; i++)
@@ -38,14 +39,15 @@
       }
 
-    // commit interface
+    // commit interface -> scan all entry (Out of Order)
     for (uint32_t i=0; i<_param->_nb_inst_commit; i++)
       {
         commit_ack        [i] = false;
 
-	// Test if have instruction
+	// Test if have valid instruction
 	if (PORT_READ(in_COMMIT_VAL [i]))
 	  {
-	    Tpacket_t packet          = (_param->_have_port_rob_ptr  )?PORT_READ(in_COMMIT_PACKET_ID [i]):0;
-	    uint32_t  num_bank        = packet >> _param->_shift_num_bank;
+            // packet_id number can 
+	    Tpacket_t packet_id       = (_param->_have_port_rob_ptr  )?PORT_READ(in_COMMIT_PACKET_ID [i]):0;
+	    uint32_t  num_bank        = packet_id >> _param->_shift_num_bank;
 	    uint32_t  num_bank_access = bank_nb_access [num_bank];
             
@@ -60,5 +62,5 @@
 		internal_BANK_COMMIT_NUM_INST [num_bank][num_bank_access] = i;
                 
-                Tpacket_t packet_id = packet & _param->_mask_size_bank;
+                Tpacket_t num_packet = packet_id & _param->_mask_size_bank;
                 
                 // find the good entry !!!
@@ -67,5 +69,5 @@
                      it!=_rob[num_bank].end();
                      it++)
-                  if ((*it)->ptr == packet_id)
+                  if ((*it)->ptr == num_packet)
                     {
                       entry = (*it);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_insert.cpp	(revision 100)
@@ -54,5 +54,6 @@
     std::list<generic::priority::select_t> * select_insert = _priority_insert ->select(); // same select for all insert
     std::list<generic::priority::select_t>::iterator it=select_insert ->begin();
- 
+
+    // Scan all bank ...
     for (uint32_t i=0; i<_param->_nb_bank; i++)
       {
@@ -64,4 +65,5 @@
 // 	log_printf(TRACE,Commit_unit,FUNCTION,"    * full : %d", bank_full [num_bank]);
 
+        // Scan all insert interface to find a valid transaction
 	while (it!=select_insert ->end())
 	  {
@@ -87,5 +89,5 @@
 		if (not bank_full [num_bank])
 		  {
-		    // find
+		    // find !!!
 		    insert_ack       [num_rename_unit][num_inst_insert] = true;
 
@@ -112,4 +114,5 @@
       }
     
+    // Write output
     for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
       for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 100)
@@ -48,9 +48,13 @@
 	  retire_val [i][j] = false;
       }
-
     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
       for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
-	spr_write_val [i][j] = 0;
-
+        {
+          spr_write_val [i][j] = 0;
+          spr_write_sr_f_val  [i][j] = 0;
+          spr_write_sr_cy_val [i][j] = 0;
+          spr_write_sr_ov_val [i][j] = 0;
+
+        }
     // Scan Top of each bank
     for (uint32_t i=0; i<_param->_nb_bank; i++)
@@ -64,5 +68,8 @@
 	    uint32_t   x     = entry->rename_unit_id;
 	    uint32_t   y     = num_inst_retire [x];
-	    
+	
+            // test if :
+            //  * can retire (all previous instruction is retired)
+            //  * all structure is ok (not busy)
 	    if (can_retire [x] and // in-order
 		(y < _param->_nb_inst_retire [x]) and
@@ -71,7 +78,8 @@
 		rob_state_t state = entry->state;
 		
-		if ((state == ROB_END_OK  ) or 
-		    (state == ROB_END_KO  ) or 
-		    (state == ROB_END_MISS)//  or 
+		if ((state == ROB_END_OK         ) or 
+		    (state == ROB_END_KO         ) or 
+		    (state == ROB_END_BRANCH_MISS) or 
+		    (state == ROB_END_MISS       )//  or 
 // 		    (state == ROB_END_EXCEPTION)
 		    )
@@ -85,5 +93,7 @@
 		    bool spr_write_ack = true;
 
+                    // Write in SR the good flag
 		    if ((state == ROB_END_OK  ) and write_re)
+                      // ROB_END_BRANCH_MISS is a valid branch instruction but don't modify RE
 		      {
 			spr_write_ack = PORT_READ(in_SPR_WRITE_ACK [front_end_id][context_id]);
@@ -138,5 +148,5 @@
 		    PORT_WRITE(out_RETIRE_CONTEXT_ID            [x][y], context_id                  );
 // 		    PORT_WRITE(out_RETIRE_RENAME_UNIT_ID        [x][y], entry->rename_unit_id       );
-		    PORT_WRITE(out_RETIRE_EVENT_STATE           [x][y], entry->event_state          );
+		    PORT_WRITE(out_RETIRE_EVENT_STATE           [x][y], reg_EVENT_STATE[front_end_id][context_id]);
 		    PORT_WRITE(out_RETIRE_USE_STORE_QUEUE       [x][y], entry->use_store_queue      );
 		    PORT_WRITE(out_RETIRE_USE_LOAD_QUEUE        [x][y], entry->use_load_queue       );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 100)
@@ -28,4 +28,7 @@
     // ===================================================================
     {
+      // Store instruction comming Out Of Order in Load Store Unit. 
+      // Must be executed in no speculative mode. Also, send a signal when an Store is in head of ROB
+
       Tcontrol_t val = false;
 
@@ -35,4 +38,5 @@
 	  rob_state_t  state = entry->state;
 
+          // Test state
 	  val   = ((state == ROB_STORE_HEAD_OK) or
 		   (state == ROB_STORE_HEAD_KO));
@@ -40,4 +44,5 @@
 	  if (val)
 	    {
+              // Reexecute store
 	      if (_param->_have_port_context_id)
   	      PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [0], entry->context_id           );
@@ -62,6 +67,8 @@
     // ===================================================================
     {
+      // Branchement must be send at the prediction unit
       uint32_t nb_scan_bank = 0;
 
+      // for each port, find a valid branchement.
       for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
 	{
@@ -72,4 +79,5 @@
 	      nb_scan_bank ++;
 
+              // translate bank number
 	      uint32_t num_bank = (reg_NUM_BANK_HEAD+j)%_param->_nb_bank;
 	      
@@ -124,16 +132,4 @@
 	}
     }
-
-//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_VAL                        ;
-//   public    : SC_IN (Tcontrol_t         )   *  in_UPDATE_ACK                        ;
-//   public    : SC_OUT(Tcontext_t         )   * out_UPDATE_CONTEXT_ID                 ;
-//   public    : SC_OUT(Tcontext_t         )   * out_UPDATE_FRONT_END_ID               ;
-//   public    : SC_OUT(Tdepth_t           )   * out_UPDATE_DEPTH                      ;
-//   public    : SC_OUT(Tevent_type_t      )   * out_UPDATE_TYPE                       ;
-//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_IS_DELAY_SLOT              ;
-//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS                    ;
-//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS_EPCR               ;
-//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_ADDRESS_EEAR_VAL           ;
-//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS_EEAR               ;
  
     // ===================================================================
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 98)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 100)
@@ -57,4 +57,7 @@
       _stat->create_expr_average_by_cycle("average_inst_retire_ko", sum_nb_inst_retire_ko, "", _("Average instruction retire ko (event, miss) by cycle"));
       _stat->create_expr_average_by_cycle("average_inst_retire"   , "+ "+sum_nb_inst_retire_ok+" "+sum_nb_inst_retire_ko, "", _("Average instruction retire by cycle"));
+
+      _stat->create_expr                 ("IPC", "average_inst_retire_ok", TYPE_COUNTER, "inst/cycle", "Instruction Per Cycle");
+      _stat->create_expr                 ("CPI", "/ 1 IPC"               , TYPE_COUNTER, "cycle/inst", "Cycle Per Instruction");
     }
 
